searchData={"items":[{"type":"module","title":"Expublish","doc":"Main module combining all release stages.","ref":"Expublish.html"},{"type":"function","title":"Expublish.alpha/1","doc":"Publish alpha version of current project.","ref":"Expublish.html#alpha/1"},{"type":"function","title":"Expublish.beta/1","doc":"Publish beta version of current project.","ref":"Expublish.html#beta/1"},{"type":"function","title":"Expublish.major/1","doc":"Publish major version of current project.","ref":"Expublish.html#major/1"},{"type":"function","title":"Expublish.minor/1","doc":"Publish minor version of current project.","ref":"Expublish.html#minor/1"},{"type":"function","title":"Expublish.patch/1","doc":"Publish patch version of current project.","ref":"Expublish.html#patch/1"},{"type":"function","title":"Expublish.rc/1","doc":"Publish release-candidate version of current project.","ref":"Expublish.html#rc/1"},{"type":"function","title":"Expublish.stable/1","doc":"Removes pre-release and publish version of current project.","ref":"Expublish.html#stable/1"},{"type":"type","title":"Expublish.level/0","doc":"","ref":"Expublish.html#t:level/0"},{"type":"module","title":"Expublish.Changelog","doc":"Functions to manipulate CHANGELOG.md and RELEASE.md.","ref":"Expublish.Changelog.html"},{"type":"function","title":"Expublish.Changelog.build_title/3","doc":"Build changelog entry title with version and ISO 8601 date.\n\nFormats current or given `NaiveDateTime` to ISO 8601 date string.\nCan be changed to date-time representation with the `--changelog-date-time` option.","ref":"Expublish.Changelog.html#build_title/3"},{"type":"function","title":"Expublish.Changelog.remove_release_file!/3","doc":"Removes RELEASE.md.","ref":"Expublish.Changelog.html#remove_release_file!/3"},{"type":"function","title":"Expublish.Changelog.validate/1","doc":"Validate changelog setup. Returns :ok or error message.","ref":"Expublish.Changelog.html#validate/1"},{"type":"function","title":"Expublish.Changelog.write_entry!/2","doc":"Generate new changelog entry from RELEASE.md contents.","ref":"Expublish.Changelog.html#write_entry!/2"},{"type":"module","title":"Expublish.Git","doc":"Shell commands for git.","ref":"Expublish.Git.html"},{"type":"function","title":"Expublish.Git.commit_and_tag/2","doc":"Create a git commit and tag for given %Version{}.","ref":"Expublish.Git.html#commit_and_tag/2"},{"type":"function","title":"Expublish.Git.push/2","doc":"Git push to remote.","ref":"Expublish.Git.html#push/2"},{"type":"function","title":"Expublish.Git.validate/1","doc":"Validate state of git working directory.\n\nReturns :ok or error message.","ref":"Expublish.Git.html#validate/1"},{"type":"module","title":"Expublish.Hex","doc":"Shell commands for hex publish.","ref":"Expublish.Hex.html"},{"type":"function","title":"Expublish.Hex.publish/2","doc":"Run mix hex.publish --yes.","ref":"Expublish.Hex.html#publish/2"},{"type":"module","title":"Expublish.Options","doc":"Validate and parse mix task arguments.","ref":"Expublish.Options.html"},{"type":"function","title":"Expublish.Options.defaults/0","doc":"Default options used for every run.\n\n```\n%Expublish.Options{\n  remote: \"origin\",\n  help: false,\n  branch: \"master\",\n  dry_run: false,\n  changelog_date_time: false,\n  allow_untracked: false,\n  commit_prefix: \"Version release\",\n  tag_prefix: \"v\",\n  disable_push: false,\n  disable_publish: false,\n  as_major: false,\n  as_minor: false,\n  disable_test: false,\n  version_file: \"mix.exs\"\n}\n```","ref":"Expublish.Options.html#defaults/0"},{"type":"function","title":"Expublish.Options.parse/1","doc":"Parse mix task arguments and merge with default options.","ref":"Expublish.Options.html#parse/1"},{"type":"function","title":"Expublish.Options.print_help/0","doc":"Print help to stdout.","ref":"Expublish.Options.html#print_help/0"},{"type":"function","title":"Expublish.Options.validate/2","doc":"Validates options and level combinations.\n\nReturns :ok or error message.","ref":"Expublish.Options.html#validate/2"},{"type":"type","title":"Expublish.Options.level/0","doc":"","ref":"Expublish.Options.html#t:level/0"},{"type":"type","title":"Expublish.Options.t/0","doc":"","ref":"Expublish.Options.html#t:t/0"},{"type":"module","title":"Expublish.Project","doc":"Functions for reading and writing project mix.exs.","ref":"Expublish.Project.html"},{"type":"function","title":"Expublish.Project.get_version!/1","doc":"Return parsed %Version{} from current mix project.\n\nReads from `Mix.Project.config/0`","ref":"Expublish.Project.html#get_version!/1"},{"type":"function","title":"Expublish.Project.update_version!/3","doc":"Writes version to project mix.exs or given --version-file.","ref":"Expublish.Project.html#update_version!/3"},{"type":"module","title":"Expublish.Semver","doc":"Functions for manipulating [%Version{}](https://hexdocs.pm/elixir/Version.html).","ref":"Expublish.Semver.html"},{"type":"function","title":"Expublish.Semver.alpha/2","doc":"Bump alpha pre-release and patch version.","ref":"Expublish.Semver.html#alpha/2"},{"type":"function","title":"Expublish.Semver.beta/2","doc":"Bump beta pre-release and patch version.","ref":"Expublish.Semver.html#beta/2"},{"type":"function","title":"Expublish.Semver.increase!/3","doc":"Interfaces `Expublish.Semver` version increase functions.","ref":"Expublish.Semver.html#increase!/3"},{"type":"function","title":"Expublish.Semver.major/1","doc":"Bump major version.","ref":"Expublish.Semver.html#major/1"},{"type":"function","title":"Expublish.Semver.minor/1","doc":"Bump minor version.","ref":"Expublish.Semver.html#minor/1"},{"type":"function","title":"Expublish.Semver.patch/1","doc":"Bump patch version.","ref":"Expublish.Semver.html#patch/1"},{"type":"function","title":"Expublish.Semver.rc/2","doc":"Bump release-candidate pre-release and patch version.","ref":"Expublish.Semver.html#rc/2"},{"type":"function","title":"Expublish.Semver.stable/1","doc":"Remove current pre-release suffix and declare current version stable.","ref":"Expublish.Semver.html#stable/1"},{"type":"type","title":"Expublish.Semver.level/0","doc":"","ref":"Expublish.Semver.html#t:level/0"},{"type":"module","title":"Expublish.Tests","doc":"Shell commands for triggering mix test.","ref":"Expublish.Tests.html"},{"type":"function","title":"Expublish.Tests.validate/2","doc":"Run tests, stop task if they fail, skip if there are none.","ref":"Expublish.Tests.html#validate/2"},{"type":"type","title":"Expublish.Tests.level/0","doc":"","ref":"Expublish.Tests.html#t:level/0"},{"type":"task","title":"mix expublish","doc":"Mix tasks for releasing and publishing new project versions.\n\nOptionParser interface defined in `Expublish.Options.`","ref":"Mix.Tasks.Expublish.html"},{"type":"task","title":"mix expublish.alpha","doc":"Release and publish alpha pre-release for next major version of current project.\n\nNext version level controlled via mix task arguments defined as `Expublish.Options`.","ref":"Mix.Tasks.Expublish.Alpha.html"},{"type":"task","title":"mix expublish.beta","doc":"Release and publish beta pre-release for next major version of current project.\n\nNext version level controlled via mix task arguments defined as `Expublish.Options`.","ref":"Mix.Tasks.Expublish.Beta.html"},{"type":"task","title":"mix expublish.major","doc":"Release and publish next major version of current project.\n\nOptionParser interface defined in `Expublish.Options.`","ref":"Mix.Tasks.Expublish.Major.html"},{"type":"task","title":"mix expublish.minor","doc":"Release and publish next minor version of current project.\n\nOptionParser interface defined in `Expublish.Options.`","ref":"Mix.Tasks.Expublish.Minor.html"},{"type":"task","title":"mix expublish.patch","doc":"Release and publish next patch version of current project.\n\nOptionParser interface defined in `Expublish.Options.`","ref":"Mix.Tasks.Expublish.Patch.html"},{"type":"task","title":"mix expublish.rc","doc":"Release and publish alpha pre-release for next major version of current project.\n\nNext version level controlled via mix task arguments defined as `Expublish.Options`.","ref":"Mix.Tasks.Expublish.Rc.html"},{"type":"task","title":"mix expublish.stable","doc":"Removes pre-release from version and publishes current project.\n\nOptionParser interface defined in `Expublish.Options.`","ref":"Mix.Tasks.Expublish.Stable.html"},{"type":"extras","title":"README","doc":"[![Hex.pm](https://img.shields.io/hexpm/v/expublish)](https://hex.pm/packages/expublish)\n[![Hexdocs.pm](https://img.shields.io/badge/docs-hexdocs.pm-purple)](https://hexdocs.pm/expublish)\n[![Github.com](https://github.com/ucwaldo/expublish/actions/workflows/elixir.yml/badge.svg)](https://github.com/ucwaldo/expublish/actions)\n[![Coverage Status](https://coveralls.io/repos/github/ucwaldo/expublish/badge.svg?branch=master)](https://coveralls.io/github/ucwaldo/expublish?branch=master)\n\n# Expublish\n\nAutomates semantic release versioning and best practices for elixir packages.\n\nExplublish helps keeping a clean and trackable version history in a project,\nwhile providing a consistent and easy release experience to its maintainers.\nIt was created with a continuous release process in mind and can be used to\nfully automate the release of new package versions.","ref":"readme.html"},{"type":"extras","title":"What it does - README","doc":"Inspired by various release utilities that exist for different languages and ecosystems,\nExpublish provides a mix task that guarantees a clean and functioning project state\nbefore it performs the steps required to release a new package version following\n[semantic versioning](https://semver.org/) conventions.\n\nUsing `mix expublish` guarantees:\n\n- a clean git working directory.\n- passing tests.\n- an increased version in mix.exs or version file.\n- a new curated changelog entry.\n- a new version git commit and tag.\n- `git push` to given remote and branch.\n- `mix hex.publish` to release the new package version and documentation to users.\n\nSome of the steps can be opted out from and when not executed from CI,\nit's recommended to _always_ execute a `--dry-run` before rerunning the expublish task without said option.\n\n`mix expublish` supports various command-line options, check out the [Cheatsheet](./docs/CHEATSHEET.md) and [Reference](./docs/REFERENCE.md) pages.","ref":"readme.html#what-it-does"},{"type":"extras","title":"Getting started - README","doc":"1\\. Follow the [installation](./docs/INSTALLATION.md) instructions.\n\n2\\. For every new release, create a `RELEASE.md` containing a new changelog entry:\n\n```bash\n$ echo \"- changelog entry one\\n- changelog entry two\" > RELEASE.md\n```\n\n3\\. Run `mix expublish`:\n\n```bash\n$ mix expublish.minor\n```\n\n_Note that in case the push or publish step fail because of missing authentication\nor a failing network, the task must not be rerun. Instead run `git push` or\n`mix hex.publish` to finish releasing the new version._","ref":"readme.html#getting-started"},{"type":"extras","title":"Installation - README","doc":"See the [Installation](./docs/INSTALLATION.md) page to learn how to set up Expublish.","ref":"readme.html#installation"},{"type":"extras","title":"Cheatsheet - README","doc":"See the [Cheatsheet](./docs/CHEATSHEET.md) page to get a quick overview on how to use the various options.","ref":"readme.html#cheatsheet"},{"type":"extras","title":"Version levels - README","doc":"See the [Version levels](./docs/VERSION_LEVELS.md) page to learn how Expublish increases version levels.","ref":"readme.html#version-levels"},{"type":"extras","title":"Quick Reference - README","doc":"See the full [Reference](./docs/REFERENCE.md) page to learn about all valid `mix expublish`\ntask levels, options and defaults.\n\n```bash\nUsage: mix expublish.[level] [options]\n\nlevel:\n  major   - Publish next major version\n  minor   - Publish next minor version\n  patch   - Publish next patch version\n  stable  - Publish current stable version from pre-release\n  rc      - Publish release-candidate pre-release of next patch version\n  beta    - Publish beta pre-release of next patch version\n  alpha   - Publish alpha pre-release of next patch version\n\noptions:\n  -d, --dry-run           - Perform dry run (no writes, no commits)\n  --allow-untracked       - Allow untracked files during release\n  --as-major              - Only for pre-release level\n  --as-minor              - Only for pre-release level\n  --disable-publish       - Disable hex publish\n  --disable-push          - Disable git push\n  --disable-test          - Disable test run\n  --changelog-date-time   - Use date-time instead of date in new changelog entry\n  --branch=string         - Remote branch to push to, default: \"master\"\n  --remote=string         - Remote name to push to, default: \"origin\"\n  --commit-prefix=string  - Custom commit prefix, default:  \"Version release\"\n  --tag-prefix=string     - Custom tag prefix, default: \"v\"\n  --version-file=string   - When working with a separate version file\n```","ref":"readme.html#quick-reference"},{"type":"extras","title":"Links and resources - README","doc":"- [Hex.pm docs](https://hex.pm/docs/usage)\n- [Keep a changelog](https://keepachangelog.com/en/1.1.0/)\n- [SemVer specification](https://semver.org/)\n- [Blog post on private hex auth](https://medium.com/@brunoripa/elixir-application-deployment-using-a-ci-and-private-hex-pm-dependencies-23f45fe04973)\n- [Example github action](https://github.com/ucwaldo/expublish/blob/master/.github/workflows/release.yml#L31-L42)","ref":"readme.html#links-and-resources"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\n<!-- %% CHANGELOG_ENTRIES %% -->","ref":"changelog.html"},{"type":"extras","title":"2.7.4 - 2024-01-25 - Changelog","doc":"housekeeping release\n\n- update dev dependencies\n- add styler dev dependency\n- update release gh action","ref":"changelog.html#2-7-4-2024-01-25"},{"type":"extras","title":"2.7.3 - 2022-05-03 - Changelog","doc":"- update dev dependencies\n- fix outdated docs about `--allow-untracked`","ref":"changelog.html#2-7-3-2022-05-03"},{"type":"extras","title":"2.7.2 - 2021-12-18 - Changelog","doc":"- Switch github actions to erlef/setup-beam\n- Never add untracked files with --allow-untracked\n- Fail mix task with appropriate exit code","ref":"changelog.html#2-7-2-2021-12-18"},{"type":"extras","title":"2.7.1 - 2021-03-10 - Changelog","doc":"Fix dry-run commit log output","ref":"changelog.html#2-7-1-2021-03-10"},{"type":"extras","title":"2.7.0 - 2021-03-07 - Changelog","doc":"Loosen Elixir version constraint to 1.8","ref":"changelog.html#2-7-0-2021-03-07"},{"type":"extras","title":"2.6.1 - 2021-03-05 - Changelog","doc":"Fix typos in documentation","ref":"changelog.html#2-6-1-2021-03-05"},{"type":"extras","title":"2.6.0 - 2021-03-04 - Changelog","doc":"- ISO 8601 formatted changelog entry date\n- Add excoveralls\n- Fix typos in documentation","ref":"changelog.html#2-6-0-2021-03-04"},{"type":"extras","title":"2.5.5 - 2021-03-02 - Changelog","doc":"Cleanup module docs","ref":"changelog.html#2-5-5-2021-03-02"},{"type":"extras","title":"2.5.4 - 2021-03-01 - Changelog","doc":"- Rename version_file.ex to more appropriate project.ex\n- More Documentation\n- License file","ref":"changelog.html#2-5-4-2021-03-01"},{"type":"extras","title":"2.5.3 - 2021-03-01 - Changelog","doc":"Important note on push/publish failure","ref":"changelog.html#2-5-3-2021-03-01"},{"type":"extras","title":"2.5.2 - 2021-03-01 - Changelog","doc":"Improve installation docs","ref":"changelog.html#2-5-2-2021-03-01"},{"type":"extras","title":"2.5.1 - 2021-02-28 - Changelog","doc":"Verify separate version file before writing to it","ref":"changelog.html#2-5-1-2021-02-28"},{"type":"extras","title":"2.5.0 - 2021-02-28 - Changelog","doc":"- Support updating project version in module attribute\n- Support --version-file option considered when updating project version\n- Update Documentation","ref":"changelog.html#2-5-0-2021-02-28"},{"type":"extras","title":"2.4.5 - 2021-02-28 - Changelog","doc":"Clarify push and publishing task behavior in docs","ref":"changelog.html#2-4-5-2021-02-28"},{"type":"extras","title":"2.4.4 - 2021-02-28 - Changelog","doc":"- Do not patch higher pre-release level while on pre-release\n- Add missing match in option validation\n- Mark dependencies as optional","ref":"changelog.html#2-4-4-2021-02-28"},{"type":"extras","title":"2.4.3 - 2021-02-27 - Changelog","doc":"Fix typo in readme","ref":"changelog.html#2-4-3-2021-02-27"},{"type":"extras","title":"2.4.2 - 2021-02-27 - Changelog","doc":"Update hex.pm links and create docs folder","ref":"changelog.html#2-4-2-2021-02-27"},{"type":"extras","title":"2.4.1 - 2021-02-27 - Changelog","doc":"Cleanup Expublish.Semver","ref":"changelog.html#2-4-1-2021-02-27"},{"type":"extras","title":"2.4.0 - 2021-02-27 - Changelog","doc":"- Add support for pre-release levels: alpha, beta and rc\n- Restructured Documentation","ref":"changelog.html#2-4-0-2021-02-27"},{"type":"extras","title":"2.3.4 - 2021-02-25 - Changelog","doc":"Add typespecs and dialyzer check","ref":"changelog.html#2-3-4-2021-02-25"},{"type":"extras","title":"2.3.3 - 2021-02-25 - Changelog","doc":"- Reformat print help\n- Improved documentation","ref":"changelog.html#2-3-3-2021-02-25"},{"type":"extras","title":"2.3.2 - 2021-02-24 - Changelog","doc":"Add more documentation","ref":"changelog.html#2-3-2-2021-02-24"},{"type":"extras","title":"2.3.1 - 2021-02-24 - Changelog","doc":"Improve invalid option log","ref":"changelog.html#2-3-1-2021-02-24"},{"type":"extras","title":"2.3.0 - 2021-02-24 - Changelog","doc":"- Run static code analysis in github action\n- Print test output in mix shell\n- Add credo","ref":"changelog.html#2-3-0-2021-02-24"},{"type":"extras","title":"2.2.4 - 2021-02-24 - Changelog","doc":"- Unify system calls\n- Consistent logging","ref":"changelog.html#2-2-4-2021-02-24"},{"type":"extras","title":"2.2.3 - 2021-02-23 - Changelog","doc":"Make task fail on invalid options","ref":"changelog.html#2-2-3-2021-02-23"},{"type":"extras","title":"2.2.2 - 2021-02-23 - Changelog","doc":"Refactor mix task options","ref":"changelog.html#2-2-2-2021-02-23"},{"type":"extras","title":"2.2.1 - 2021-02-23 - Changelog","doc":"fix Mix.env check before Tests.run","ref":"changelog.html#2-2-1-2021-02-23"},{"type":"extras","title":"2.2.0 - 2021-02-23 - Changelog","doc":"- add --commit-prefix option\n- add --tag-prefix option\n- setup tests for all modules","ref":"changelog.html#2-2-0-2021-02-23"},{"type":"extras","title":"2.1.2 - 2021-02-22 - Changelog","doc":"- cleanup project validation\n- improve task logging","ref":"changelog.html#2-1-2-2021-02-22"},{"type":"extras","title":"2.1.1 - 2021-02-22 - Changelog","doc":"add missing --allow-untracked line in print help","ref":"changelog.html#2-1-1-2021-02-22"},{"type":"extras","title":"2.1.0 - 2021-02-22 - Changelog","doc":"- Add --allow-untracked\n- Documentation amends","ref":"changelog.html#2-1-0-2021-02-22"},{"type":"extras","title":"2.0.0 - 2021-02-21 - Changelog","doc":"Rename mix task to `mix expublish`","ref":"changelog.html#2-0-0-2021-02-21"},{"type":"extras","title":"1.1.1 - 2021-02-21 - Changelog","doc":"Configure github actions","ref":"changelog.html#1-1-1-2021-02-21"},{"type":"extras","title":"1.1.0 - 2021-02-21 - Changelog","doc":"Command line options","ref":"changelog.html#1-1-0-2021-02-21"},{"type":"extras","title":"1.0.0 - 2021-02-20 - Changelog","doc":"Initial release","ref":"changelog.html#1-0-0-2021-02-20"},{"type":"extras","title":"Installation","doc":"# Installation\n\n1\\. Add `:expublish` to the dev dependencies in `mix.exs`:\n\n```elixir\n{:expublish, \"~> 2.5\", only: [:dev], runtime: false}\n```\n\n2\\. Create a `CHANGELOG.md` in the root folder of the project. It must contain a placeholder:\n\n```text\n<!-- %% CHANGELOG_ENTRIES %% -->\n```\n\n3\\. Put the following line in `.gitignore`:\n\n```text\nRELEASE.md\n```\n\nAlternatively, the `RELEASE.md` can be kept inside version control and used\nwhen publishing from CI. The file is deleted after every successful release.","ref":"installation.html"},{"type":"extras","title":"Package version - Installation","doc":"While writing the final package version, Expublish expects it to be located\nwhere `mix new [package]` initially placed it. If it wasn't changed, skip\nthe next couple paragraphs and read about [Publishing to hex](#publishing-to-hex).\n\nAs it is common to keep the package version in a module attribute in `mix.exs`,\nExpublish supports following syntax as well.\n\n```\n@version \"1.0.0\"\n# ...\nversion: @version\n```\n\nIf the package version is maintained in a separate file, Expublish can be made aware\nof that with the appropriate [option](./REFERENCE.md):\n\n```bash\n$ mix expublish.patch --version-file=VERSION.txt\n```\n\nwhere `VERSION.txt` is a file containing nothing but the current project version\n\n```\n1.0.0\n```\n\nand `mix.exs` reading said file in `project/0`:\n\n```\nversion: \"VERSION.txt\" |> File.read!() |> String.trim()\n```","ref":"installation.html#package-version"},{"type":"extras","title":"Publishing to hex - Installation","doc":"Before publishing a package for the first time, do read the\n[hex documentation on publishing](https://hex.pm/docs/publish) and\nadd the required metadata in mix.exs.\n\nRegardless of publishing to [hex.pm](https://hex.pm/) or a self-hosted hex repository,\nthe shell environment where `mix expublish` is being executed must authenticate for\nthe publishing step to succeed.\n\nHex.pm usually requires a valid `HEX_API_TOKEN` to be defined in the current environment,\nwhile self-hosted repositories can use a range of various authentication methods.\n\nCheck out the [hex documenation on self-hosting](https://hex.pm/docs/self_hosting)\nto learn how to maintain a private package registry.","ref":"installation.html#publishing-to-hex"},{"type":"extras","title":"Prerequisites - Installation","doc":"Expublish expects `git` and `mix` to be available at runtime but comes without any additional dependencies.","ref":"installation.html#prerequisites"},{"type":"extras","title":"Cheatsheet","doc":"# Cheatsheet\n\nExpublish supports various options that are listed in detail on the [Reference](./REFERENCE.md) page.\n\n```bash\n# Perform all task steps without writing changes (no commit, no tag, no push, no publish):\n$ mix expublish.minor --dry-run\n\n# Do not push the new version commit and tag to git and do not publish to hex:\n$ mix expublish.minor --disable-push --disable-publish\n\n# Skip test run:\n$ mix expublish.minor --disable-test\n\n# Allow untracked files while validating git working directory:\n$ mix expublish.minor --allow-untracked\n\n# If the package version is kept in a separate file:\n$ mix expublish.patch --version-file=VERSION.txt\n\n# Push to a different git branch and/or remote:\n$ mix expublish.minor --branch=release --remote=upstream\n\n# Custom tag-prefix which results in \"release-0.0.1\" instead of \"v0.0.1\":\n$ mix expublish.minor --tag-prefix=\"release-\"\n\n# Use custom commit-, but no tag-prefix:\n$ mix expublish.minor --tag-prefix=\"\" --commit-prefix=\"Version bump\"\n\n# Release a pre-release version as next major:\n$ mix expublish.alpha --as-major\n\n# Release a stable pre-release version. Aborts if current version is already stable:\n$ mix expublish.stable\n```","ref":"cheatsheet.html"},{"type":"extras","title":"Version levels","doc":"# Version levels\n\nVersion level increases follow [semantic versioning](https://semver.org/) conventions.\n\n`Expublish.Semver` defines the level type as:\n\n```\n@type level() :: :major | :minor | :patch | :rc | :beta | :alpha | :stable\n\n```\n\n#","ref":"version_levels.html"},{"type":"extras","title":"Major releases reset minor and patch levels - Version levels","doc":"```bash\n# current version: \"0.1.4\"\n\nexpublish.major => \"1.0.0\"\n```\n\n#","ref":"version_levels.html#major-releases-reset-minor-and-patch-levels"},{"type":"extras","title":"Minor releases reset patch level - Version levels","doc":"```bash\n# current version: \"0.1.4\"\n\nexpublish.minor => \"0.2.0\"\n```\n\n#","ref":"version_levels.html#minor-releases-reset-patch-level"},{"type":"extras","title":"First pre-release patches the current version by default - Version levels","doc":"```bash\n# current version: \"0.0.0\"\n\nexpublish.alpha  => \"0.0.1-alpha\"\nexpublish.beta   => \"0.0.1-beta\"\nexpublish.rc     => \"0.0.1-rc\"\n```\n\nNote that using a higher pre-release level _does not_ increase the version number.\n\n#","ref":"version_levels.html#first-pre-release-patches-the-current-version-by-default"},{"type":"extras","title":"Pre-releases can be declared stable - Version levels","doc":"```bash\n# current version: \"1.0.1-rc\"\n\nexpublish.stable => \"1.0.1\"\n```\n\nNote that `expublish.stable` only drops the pre-release suffix but  _does not_ increase the version number.\n\n#","ref":"version_levels.html#pre-releases-can-be-declared-stable"},{"type":"extras","title":"An already stable version can not be redeclared stable - Version levels","doc":"```bash\n# current version: \"1.0.1\"\n\nexpublish.stable => Error: can not release already stable version \"1.0.1\"\n```\n\n#","ref":"version_levels.html#an-already-stable-version-can-not-be-redeclared-stable"},{"type":"extras","title":"Pre-release levels can not be applied backwards - Version levels","doc":"```bash\n# current version: \"1.0.0-rc\"\n\nexpublish.alpha  => Error: current version rc > alpha\nexpublish.beta   => Error: current version rc > beta\nexpublish.rc     => \"1.0.1-rc\"\n```\n\n#","ref":"version_levels.html#pre-release-levels-can-not-be-applied-backwards"},{"type":"extras","title":"Patch and current pre-release levels can be used interchangeably - Version levels","doc":"```bash\n# current version: \"0.1.4-beta\"\n\nexpublish.patch => \"0.1.5-beta\"\nexpublish.beta  => \"0.1.6-beta\"\nexpublish.patch => \"0.1.7-beta\"\nexpublish.rc    => \"0.1.7-rc\"\nexpublish.patch => \"0.1.8-rc\"\n```\n\n#","ref":"version_levels.html#patch-and-current-pre-release-levels-can-be-used-interchangeably"},{"type":"extras","title":"Pre-releases can increase by different version levels - Version levels","doc":"```bash\n# current version: \"0.0.0\"\n\nexpublish.alpha           => \"0.0.1-alpha\"\nexpublish.beta --as-minor => \"0.1.0-beta\"\nexpublish.rc --as-major   => \"1.0.0-rc\"\n```\n\n#","ref":"version_levels.html#pre-releases-can-increase-by-different-version-levels"},{"type":"extras","title":"Pre-release levels can be skipped - Version levels","doc":"```bash\n# current version: \"1.0.1-alpha\"\n\nexpublish.rc => \"1.0.1-rc\"\n```","ref":"version_levels.html#pre-release-levels-can-be-skipped"},{"type":"extras","title":"Reference","doc":"# Reference\n\nExpublish defines the mix task as:\n\n```\nmix expublish.[level] [options]\n```","ref":"reference.html"},{"type":"extras","title":"Levels - Reference","doc":"| Level    | Description                                                               |\n| -------- | ------------------------------------------------------------------------- |\n| `major`  | When making incompatible API changes.                                     |\n| `minor`  | When adding functionality in a backwards compatible manner.               |\n| `patch`  | When making backwards compatible bug fixes.                               |\n| `stable` | When declaring a pre-release stable. Version level will not be increased. |\n| `rc`     | Pre-release for final test stage of next patch version.                   |\n| `beta`   | Pre-release for later test stage of next patch version.                   |\n| `alpha`  | Pre-release for early test stage of next patch version.                   |\n\nPre-releases are always considered unstable, however their next version level can\nstill be changed by using one of the `--as-major` or `--as-minor` options.","ref":"reference.html#levels"},{"type":"extras","title":"Options - Reference","doc":"| Option                   | Default             | Description                                          |\n| ------------------------ | ------------------- | ---------------------------------------------------- |\n| `-d, --dry-run`          | `false`             | Perform dry run release                              |\n| `-h, --help`             | `false`             | Print help                                           |\n| `--allow-untracked`      | `false`             | Allow untracked files                                |\n| `--as-major`             | `false`             | Only for pre-release level                           |\n| `--as-minor`             | `false`             | Only for pre-release level                           |\n| `--disable-publish`      | `false`             | Disable hex publish                                  |\n| `--disable-push`         | `false`             | Disable git push                                     |\n| `--disable-test`         | `false`             | Disable test run                                     |\n| `--changelog-date-time`  | `false`             | Use date-time instead of date in new changelog entry |\n| `--branch=string`        | `\"master\"`          | Remote branch for git push                           |\n| `--remote=string`        | `\"origin\"`          | Remote name for git push                             |\n| `--commit-prefix=string` | `\"Version release\"` | Prefix for commit message                            |\n| `--tag-prefix=string`    | `\"v\"`               | Prefix for release tag                               |\n| `--version-file=string`  | `\"mix.exs\"`         | When working with a separate version file \\*         |\n\n\\* Expublish expects given file to contain _nothing_ but the current version of a\nproject and will overwrite the file with the new version while releasing.","ref":"reference.html#options"}],"content_type":"text/markdown"}